<template>
  <div>
    <Modal ref="cuposModal" :size="'lg'" :title="cuposCampos.titulo">
      <CuposModal :parametros="cuposCampos.parametros"></CuposModal>
    </Modal>
    <div class="row mb-3" v-if="haySolicitantes">
      <table class="table table-striped">
        <thead>
          <tr class="bg-princial text-light fs-5 text-uppercase text-center">
            <th scope="col text-center" style="padding: 7px !important">Apellido/s y Nombre/s</th>
            <th scope="col text-center" style="padding: 7px  !important">Cargo</th>
            <th scope="col text-center" style="padding: 7px  !important">Bloque</th>
            <th scope="col text-center" style="padding: 7px  !important">Secci&oacute;n</th>
            <th scope="col text-center" style="padding: 7px  !important">C&oacute;d. Safin</th>
            <th scope="col text-center" style="padding: 7px  !important">Cupo +- Transf.</th>
            <th scope="col text-center" style="padding: 7px  !important">Gastado</th>
            <th scope="col text-center" style="padding: 7px  !important">Liquidado</th>
            <th scope="col text-center" style="padding: 7px  !important">Anulado</th>
            <th scope="col text-center" style="padding: 7px  !important">Disponible</th>
            <th scope="col text-center" style="padding: 7px  !important">Reemplaza</th>
            <th scope="col text-center" style="padding: 7px !important">Acciones</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="solicitante in solicitantesStore.solicConsulta" class="fs-6"
            :class='{ "table-danger": esBaja(solicitante) }' :key="solicitante.id_tabla_sol">
            <td class="pt-2 pb-1 px-1 ps-3" v-text="solicitante.ayn"></td>
            <td class="pt-2 pb-1 px-1" v-text="solicitante.d_cargo"></td>
            <td class="pt-2 pb-1 px-1" v-text="solicitante.d_dependen"></td>
            <td class="pt-2 pb-1 px-1" v-text="solicitante.sec_electoral"></td>
            <td class="pt-2 pb-1 px-1" v-text="solicitante.cod_safin"></td>
            <td class="pt-2 pb-1 px-1 text-right" v-text="importeMostrar(solicitante.tot_cupoytransf)"></td>
            <td class="pt-2 pb-1 px-1 text-right" v-text="importeMostrar(solicitante.tot_gastado)"></td>
            <td class="pt-2 pb-1 px-1 text-right" v-text="importeMostrar(solicitante.tot_liquidado)"></td>
            <td class="pt-2 pb-1 px-1 text-right" v-text="importeMostrar(solicitante.tot_anulado)"></td>
            <td class="pt-2 pb-1 px-1 text-right" v-text="importeMostrar(solicitante.tot_disponible)"></td>
            <td class="pt-2 pb-1 px-1" v-text="solicitante.ayn_reemplaza"></td>
            <td class="pt-2 pb-1 px-1 text-center">
              <button class="btn btn-principal btn-sm pt-0 pb-0 px-1 mx-1" alt="Ver cupos del solicitante"
                title="Ver cupos del solicitante" @click="verCupos(solicitante)">
                <i class="bi bi-search"></i>
              </button>
            </td>
          </tr>
        </tbody>
        <tfoot>
          <tr class="bg-princial text-light fs-5 text-uppercase text-center">
            <th scope="col text-center" style="padding: 7px !important" v-text='"TOTALES:"'></th>
            <th scope="col text-center" style="padding: 7px !important" colspan="4"></th>
            <th scope="col text-center" style="padding: 7px !important"
              v-text="importeMostrar(totSolicitantes.cupoytransf)"></th>
            <th scope="col text-center" style="padding: 7px !important" v-text="importeMostrar(totSolicitantes.gastado)">
            </th>
            <th scope="col text-center" style="padding: 7px !important"
              v-text="importeMostrar(totSolicitantes.liquidado)"></th>
            <th scope="col text-center" style="padding: 7px !important" v-text="importeMostrar(totSolicitantes.anulado)">
            </th>
            <th scope="col text-center" style="padding: 7px !important"
              v-text="importeMostrar(totSolicitantes.disponible)"></th>
            <th scope="col text-center" style="padding: 7px !important" colspan="2"></th>
          </tr>
        </tfoot>
      </table>
    </div>
    <div v-else class="alert alert-secondary text-center" role="alert">
      No se ha encontrado ning&uacute;n solicitante en el sistema.
    </div>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { DateTime } from "luxon";
import { computed, ref } from "vue";
import type { PropType } from "vue";
import { Modal } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
// Componentes
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";
// Entidades
import type Solicitante from "@/entities/Solicitante";
// Stores
import { useSolicitantesStore } from "@/stores/solicitantes";
import { isEmpty } from "@hcd-bsas/vue3-components";
import { formToJSON } from "axios";

const solicitantesStore = useSolicitantesStore();

const props = withDefaults(defineProps<{
  usarPerfilConsulta: number | null
}>(), {
  usarPerfilConsulta: null
});

const haySolicitantes = computed(() => solicitantesStore.solicConsulta.length > 0);
/*
const cupoytransf = computed(() => solicitantesStore.solicConsulta.map(a => a.tot_cupoytransf).reduce(function (a, b) {
  return a + b;
}));
*/
const totSolicitantes = computed(() => {
  return {
    cupoytransf: solicitantesStore.solicConsulta.map(a => a.tot_cupoytransf).reduce(function (a, b) {
      return a + b;
    }),
    gastado: solicitantesStore.solicConsulta.map(a => a.tot_gastado).reduce(function (a, b) {
      return a + b;
    }),
    liquidado: solicitantesStore.solicConsulta.map(a => a.tot_liquidado).reduce(function (a, b) {
      return a + b;
    }),
    anulado: solicitantesStore.solicConsulta.map(a => a.tot_anulado).reduce(function (a, b) {
      return a + b;
    }),
    disponible: solicitantesStore.solicConsulta.map(a => a.tot_disponible).reduce(function (a, b) {
      return a + b;
    })
  };
});

const cuposModal = ref(Modal);
const cuposCampos = ref({
  titulo: null as String | null,
  parametros: {
    f_cupo_des: null as String | null,
    f_cupo_has: null as String | null,
    id_tabla_sol: null as Number | null,
    usar_perfil_consulta: null as Number | null,
  }
});

const concatMostrar = (cadena_1: string | null, cadena_2: string | null) => (!isEmpty(cadena_1) && !isEmpty(cadena_2)) ? cadena_1!.concat(' ', cadena_2!) : null;
const fechaMostrar = (fecha: string | undefined) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha!).toFormat('dd/MM/yyyy') : null;
const mesMostrar = (mes: number | null) => (mes !== null) ? DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)') : "";
const importeMostrar = (importe: number) => Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe);

function esBaja(solicitante: Solicitante): boolean {
  return (solicitante.estado === "B");
}

function verCupos(solicitante: Solicitante) {
  cuposCampos.value.titulo = 'Cupos del solicitante "' + solicitante.ayn + '"' +
    ' desde el ' + fechaMostrar(solicitante.periodo + '-03-01') +
    ' hasta el ' + fechaMostrar(solicitante.periodo + '-12-31');
  cuposCampos.value.parametros = {
    f_cupo_des: solicitante.periodo + '-03-01',
    f_cupo_has: solicitante.periodo + '-12-31',
    id_tabla_sol: solicitante.id_tabla_sol,
    usar_perfil_consulta: props.usarPerfilConsulta
  };
  cuposModal.value?.show();
}
</script>
